import dzzd.DzzD;
import dzzd.*;

import java.awt.event.KeyEvent;
import java.awt.*;


public final class DzzDDemoApplet extends DzzDApplet implements IScene3DRenderCallBack
{
	boolean loaded;
	ICamera3D cam;
	IPoint3D camRotation;
	IPoint3D camPosition;
	IAxis3D camAxis;
	double speed=10;
	double jetpack=5;
	double fuel;	
	
	
	ISolidSphere3D is;
	String model1File="QUAKECOMP2.3DS";
	String model1Base="QUAKE1/";
	int nb=0;
	
  	/**
     * Init 3DzzD 
     */
	public void init3DzzD()
	{		
		String baseURL=this.getBaseURL();
		this.getScene3DRender().setScene3DRenderCallBack(this);
		this.loaded=false;
		this.is=DzzD.newSolidSphere3D();
		this.is.setRadius(80);
		this.is.getSource().set(0,100,0);
		
		this.getScene3DRender().getScene3D().loadScene3DFrom3DS(baseURL+this.model1Base,this.model1File);
	}
	
  	/**
     * Start 3DzzD 
     */
	public void start3DzzD()
	{
		
	}	

	
	public void render3DObjectMonitor(IScene3DRender r)
	{
		if(r.getScene3D().getMesh3DByName(this.model1File)==null)
		{
			Graphics g=r.getRender3D().getCanvas().getGraphics();
			int cw=r.getRender3D().getWidth()>>1;
			int ch=r.getRender3D().getHeight()>>1;
			g.setFont(new Font("Arial",Font.BOLD,24));
			g.setColor(new Color(((0xFF-(this.nb&0xFF))<<16)|(this.nb&0xFF)));
			String load="LOADING";
			for(int n=0;n<(this.nb/10);n++)
				load+=".";
			g.drawString(load,cw-50,ch);			
			Thread.yield();
			g.setFont(new Font("Arial",Font.ITALIC,16));
			g.setColor(new Color(0x555555));
			g.drawString("please wait this may take some time (>1min)",cw-140,ch+25);
			r.getRender3D().setScreenUpdateEnabled(false);
			this.nb++;
			try
			{
				Thread.sleep(100);
			}
			catch(InterruptedException ie)
			{
			}
			return;
		}
		r.getRender3D().setScreenUpdateEnabled(true);
		if(!this.loaded)
		{	
			int idcam=0;
	
			r.getScene3D().setCurrentCamera3DById(idcam);
			r.getScene3D().getCamera3DById(idcam).setFOV(45);  
			r.getScene3D().getMesh3DById(0).zoom(15,15,15);
			
	
			//Set id for skybox if we found an object named Sky
			/*
			IMesh3D sky=r.getScene3D().getMesh3DByName("Sky");
			if(sky!=null)
			{
				sky.zoom(0.02,0.02,0.02);
				r.getScene3D().setSkyBoxMesh3DById(sky.getId());
				for(int n=0;n<sky.getNbFace3D();n++)
				{
					sky.getFace3D(n).getMaterial().getMappingUV().setUZoom(0.995f);
					sky.getFace3D(n).getMaterial().getMappingUV().setVZoom(0.995f);
					sky.getFace3D(n).getMaterial().getMappingUV().setUOffset(0.0025f);
					sky.getFace3D(n).getMaterial().getMappingUV().setVOffset(0.0025f);			
				}
				sky.getRenderMode().disableRenderMode(DzzD.RM_LIGHT|DzzD.RM_TEXTURE_MIPMAP|DzzD.RM_TEXTURE_BILINEAR);
			}	
			*/
			
			//Set light direction
			IPoint3D lr=r.getScene3D().getLight3DById(0).getRotation();
			lr.set(-0.8,Math.PI+0.6,0);
		
			
				
			this.cam=r.getScene3D().getCamera3DById(idcam);
			this.camRotation=cam.getRotation(); 
			this.camPosition=cam.getPosition();
			this.camAxis=cam.getAxis3D();	
			this.cam.setZMax(70000d);
			this.loaded=true;
			r.getScene3D().setBackgroundColor(0xDDDDFF);
		}
		
	}	
	
	
	public void render3DWorldSpace(IScene3DRender r)
	{
		if(!this.loaded)
			return;
			
		IDirectInput di=r.getRender3D().getDirectInput();

		//Rotate camera using mouse coordinate
		IPoint3D az=this.camAxis.getAZ();
		double rx=this.camRotation.getX(); 
		double ry=this.camRotation.getY();
		double mx=di.getMouseX();
		double my=di.getMouseY();
		this.camRotation.setY(ry+(r.getRender3D().getWidth()*0.5-mx)*6000.0/20000000.0);
		double crx=rx+(r.getRender3D().getHeight()*0.5-my)*6000.0/20000000.0;
		if(crx>Math.PI*0.5*0.8)
			crx=Math.PI*0.5*0.8;
		if(crx<-Math.PI*0.5*0.8)
			crx=-Math.PI*0.5*0.8;
		this.camRotation.setX(crx);
		
		
		 
		//Compute move vector using key pressed
		double mvx=0;
		double mvy=0;
		double mvz=0;
		if(di.isKey(KeyEvent.VK_UP))
		{   
			mvx=az.getX()*speed;
			mvy=az.getY()*speed;
			mvz=az.getZ()*speed;
		}
		
		if(di.isKey(KeyEvent.VK_DOWN))
		{   
			mvx=-az.getX()*speed;
			mvy=-az.getY()*speed;
			mvz=-az.getZ()*speed;
		}
		
		double slide=speed*0.5;
		if(di.isKey(KeyEvent.VK_RIGHT))
		{   
			IPoint3D ax=camAxis.getAX();
			mvx=mvx+ax.getX()*slide;
			mvy=mvy+ax.getY()*slide;
			mvz=mvz+ax.getZ()*slide;
		}
		
		if(di.isKey(KeyEvent.VK_LEFT))
		{   
			IPoint3D ax=camAxis.getAX();
			mvx=mvx-ax.getX()*slide;
			mvy=mvy-ax.getY()*slide;
			mvz=mvz-ax.getZ()*slide;
		}
	
 		//MOVE WITHOUT GRAVITY AND COLLISION
 		/*
		double cx=camPosition.getX();
		double cy=camPosition.getY();
		double cz=camPosition.getZ();
		camPosition.setX(cx+mvx);
		camPosition.setY(cy+mvy);
		camPosition.setZ(cz+mvz);
		*/


		//Switch Render3D on keypress
		if(di.isKey(KeyEvent.VK_H))
			if(!r.getRender3D().getImplementationName().equals("JOGL"))
				r.switchRender3D("JOGL");
				
		if(di.isKey(KeyEvent.VK_S))
			if(!r.getRender3D().getImplementationName().equals("SOFT"))
				r.switchRender3D("SOFT");				
		
		//Simulate a JetPack
		if(di.isMouseB3())
		{
			jetpack=fuel;
			if(fuel>0)	
				fuel-=0.3;
		}
		else
		{
			if(fuel<40)
				fuel+=0.1;
			jetpack=0;
			speed=15;
		}
		speed=15+15*fuel/40;
		
		//MOVE WITH GRAVITY AND COLLISION
		this.is.getDestination().setX(this.is.getSource().getX()+mvx);
		this.is.getDestination().setY(this.is.getSource().getY()+(mvy-10)+this.jetpack);
		this.is.getDestination().setZ(this.is.getSource().getZ()+mvz);
		this.is.setScene3D(r.getScene3D());
		this.is.moveSlide(3);
		
		this.cam.getPosition().copy(this.is.getSource());
		this.cam.getPosition().setY(this.is.getSource().getY()+200);	
	}
	
	public void render3DstartCallBack(IScene3DRender r){}
	public void render3DStart(IScene3DRender r){}
	public void render3DCameraSpace(IScene3DRender r){}
	public void render3DPixelsUpdate(IScene3DRender r){}
	public void render3DPixelsUpdated(IScene3DRender r){}	
	public void render3DEnd(IScene3DRender r){}		
	public void render3DSwitched(IScene3DRender r){}
}
